summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authordrbrain <drbrain@b2dd03c8-39d4-4d8f-98ff-823fe69b080e>2014-01-07 01:19:28 +0000
committerdrbrain <drbrain@b2dd03c8-39d4-4d8f-98ff-823fe69b080e>2014-01-07 01:19:28 +0000
commitd5e810dbd24cb92dc86d2d5b048f239315b15ba8 (patch)
tree0656ac1f6abe26dd1f1349f25ece23a534b1a0dc
parent738b8872ef871cbfd78730142049cd1fe94a95fa (diff)
* ChangeLog:
* lib/rubygems/basic_specification.rb (class Gem): * lib/rubygems/commands/contents_command.rb (prefix or only the files that are requir): * lib/rubygems/commands/install_command.rb (to write the specification by hand): * lib/rubygems/commands/setup_command.rb (class Gem): * lib/rubygems/commands/setup_command.rb (TEXT): * lib/rubygems/compatibility.rb (module Gem): * lib/rubygems/defaults.rb (module Gem): * lib/rubygems/deprecate.rb (module Gem): * lib/rubygems/installer.rb (class Gem): * lib/rubygems/platform.rb (class Gem): * lib/rubygems/rdoc.rb (class Gem): * lib/rubygems/request_set/lockfile.rb (class Gem): * lib/rubygems/resolver/installer_set.rb (class Gem): * lib/rubygems/resolver.rb (class Gem): * lib/rubygems/specification.rb (class Gem): * lib/rubygems/test_case.rb (class Gem): * lib/rubygems/test_case.rb (Also): * lib/rubygems/uninstaller.rb (class Gem): * lib/rubygems.rb (module Gem): * test/rubygems/test_gem.rb (class TestGem): * test/rubygems/test_gem_commands_contents_command.rb (lib): * test/rubygems/test_gem_commands_environment_command.rb (class TestGemCommandsEnvironmentCommand): * test/rubygems/test_gem_commands_install_command.rb (ERROR): * test/rubygems/test_gem_commands_update_command.rb (class TestGemCommandsUpdateCommand): * test/rubygems/test_gem_dependency_installer.rb (class TestGemDependencyInstaller): * test/rubygems/test_gem_installer.rb (load Gem): * test/rubygems/test_gem_installer.rb (gem): * test/rubygems/test_gem_request_set_lockfile.rb (GEM): * test/rubygems/test_gem_request_set_lockfile.rb (DEPENDENCIES): * test/rubygems/test_gem_specification.rb (dependencies): * test/rubygems/test_gem_specification.rb (duplicate dependency on b): * test/rubygems/test_gem_uninstaller.rb (class TestGemUninstaller): git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@44515 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
-rw-r--r--ChangeLog9
-rw-r--r--lib/rubygems.rb19
-rw-r--r--lib/rubygems/basic_specification.rb18
-rw-r--r--lib/rubygems/commands/contents_command.rb6
-rw-r--r--lib/rubygems/commands/install_command.rb20
-rw-r--r--lib/rubygems/commands/setup_command.rb16
-rw-r--r--lib/rubygems/compatibility.rb4
-rw-r--r--lib/rubygems/defaults.rb20
-rw-r--r--lib/rubygems/deprecate.rb2
-rw-r--r--lib/rubygems/installer.rb4
-rw-r--r--lib/rubygems/platform.rb2
-rw-r--r--lib/rubygems/rdoc.rb2
-rw-r--r--lib/rubygems/request_set/lockfile.rb7
-rw-r--r--lib/rubygems/resolver.rb21
-rw-r--r--lib/rubygems/resolver/installer_set.rb35
-rw-r--r--lib/rubygems/specification.rb2
-rw-r--r--lib/rubygems/test_case.rb12
-rw-r--r--lib/rubygems/uninstaller.rb2
-rw-r--r--test/rubygems/test_gem.rb102
-rw-r--r--test/rubygems/test_gem_commands_contents_command.rb6
-rw-r--r--test/rubygems/test_gem_commands_environment_command.rb2
-rw-r--r--test/rubygems/test_gem_commands_install_command.rb15
-rw-r--r--test/rubygems/test_gem_commands_update_command.rb2
-rw-r--r--test/rubygems/test_gem_dependency_installer.rb2
-rw-r--r--test/rubygems/test_gem_installer.rb8
-rw-r--r--test/rubygems/test_gem_request_set_lockfile.rb10
-rw-r--r--test/rubygems/test_gem_specification.rb50
-rw-r--r--test/rubygems/test_gem_uninstaller.rb17
28 files changed, 253 insertions, 162 deletions
diff --git a/ChangeLog b/ChangeLog
index 4ff576b1b25..bc1ab7f3a2f 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,12 @@
+Tue Jan 7 10:16:02 2014 Eric Hodel <drbrain@segment7.net>
+
+ * lib/rubygems: Update to RubyGems master 21e409d / RubyGems 2.2.1.
+
+ See http://rubygems.rubyforge.org/rubygems-update/History_txt.html
+ for a list of bug fixes.
+
+ * test/rubygems: ditto.
+
Tue Jan 7 10:10:46 2014 Eric Wong <e@80x24.org>
* ext/json/generator/depend: add build dependencies for json extension
diff --git a/lib/rubygems.rb b/lib/rubygems.rb
index 73c4846f827..7afc85bda51 100644
--- a/lib/rubygems.rb
+++ b/lib/rubygems.rb
@@ -8,7 +8,7 @@
require 'rbconfig'
module Gem
- VERSION = '2.2.0'
+ VERSION = '2.2.1'
end
# Must be first since it unloads the prelude from 1.9.2
@@ -572,7 +572,7 @@ module Gem
# gem's paths are inserted before site lib directory by default.
def self.load_path_insert_index
- index = $LOAD_PATH.index ConfigMap[:sitelibdir]
+ index = $LOAD_PATH.index RbConfig::CONFIG['sitelibdir']
index
end
@@ -743,8 +743,8 @@ module Gem
def self.prefix
prefix = File.dirname RUBYGEMS_DIR
- if prefix != File.expand_path(ConfigMap[:sitelibdir]) and
- prefix != File.expand_path(ConfigMap[:libdir]) and
+ if prefix != File.expand_path(RbConfig::CONFIG['sitelibdir']) and
+ prefix != File.expand_path(RbConfig::CONFIG['libdir']) and
'lib' == File.basename(RUBYGEMS_DIR) then
prefix
end
@@ -765,6 +765,10 @@ module Gem
f.flock(File::LOCK_EX)
f.read
end
+ rescue Errno::EACCES
+ open path, 'rb' do |f|
+ f.read
+ end
end
##
@@ -772,8 +776,8 @@ module Gem
def self.ruby
if @ruby.nil? then
- @ruby = File.join(ConfigMap[:bindir],
- "#{ConfigMap[:ruby_install_name]}#{ConfigMap[:EXEEXT]}")
+ @ruby = File.join(RbConfig::CONFIG['bindir'],
+ "#{RbConfig::CONFIG['ruby_install_name']}#{RbConfig::CONFIG['EXEEXT']}")
@ruby = "\"#{@ruby}\"" if @ruby =~ /\s/
end
@@ -785,8 +789,7 @@ module Gem
# Returns a String containing the API compatibility version of Ruby
def self.ruby_api_version
- @ruby_api_version ||=
- "#{ConfigMap[:MAJOR]}.#{ConfigMap[:MINOR]}.#{ConfigMap[:TEENY]}"
+ @ruby_api_version ||= RbConfig::CONFIG['ruby_version'].dup
end
##
diff --git a/lib/rubygems/basic_specification.rb b/lib/rubygems/basic_specification.rb
index a52377ff22e..470a6ebc8b5 100644
--- a/lib/rubygems/basic_specification.rb
+++ b/lib/rubygems/basic_specification.rb
@@ -207,6 +207,24 @@ class Gem::BasicSpecification
end
##
+ # Returns the paths to the source files for use with analysis and
+ # documentation tools. These paths are relative to full_gem_path.
+
+ def source_paths
+ paths = raw_require_paths.dup
+
+ if @extensions then
+ ext_dirs = @extensions.map do |extension|
+ extension.split(File::SEPARATOR, 2).first
+ end.uniq
+
+ paths.concat ext_dirs
+ end
+
+ paths.uniq
+ end
+
+ ##
# Return a Gem::Specification from this gem
def to_spec
diff --git a/lib/rubygems/commands/contents_command.rb b/lib/rubygems/commands/contents_command.rb
index 97218848eda..603f1d072aa 100644
--- a/lib/rubygems/commands/contents_command.rb
+++ b/lib/rubygems/commands/contents_command.rb
@@ -94,11 +94,11 @@ prefix or only the files that are requireable.
spec.files.sort.map do |file|
case file
when /\A#{spec.bindir}\//
- [Gem::ConfigMap[:bindir], $POSTMATCH]
+ [RbConfig::CONFIG['bindir'], $POSTMATCH]
when /\.so\z/
- [Gem::ConfigMap[:archdir], file]
+ [RbConfig::CONFIG['archdir'], file]
else
- [Gem::ConfigMap[:rubylibdir], file]
+ [RbConfig::CONFIG['rubylibdir'], file]
end
end
end
diff --git a/lib/rubygems/commands/install_command.rb b/lib/rubygems/commands/install_command.rb
index 4485eb12e81..8219eef6ead 100644
--- a/lib/rubygems/commands/install_command.rb
+++ b/lib/rubygems/commands/install_command.rb
@@ -228,7 +228,18 @@ to write the specification by hand. For example:
def install_gem_without_dependencies name, req # :nodoc:
gem = nil
- if remote? then
+ if local? then
+ if name =~ /\.gem$/ and File.file? name then
+ source = Gem::Source::SpecificFile.new name
+ spec = source.spec
+ else
+ source = Gem::Source::Local.new
+ spec = source.find_gem name, req
+ end
+ gem = source.download spec if spec
+ end
+
+ if remote? and not gem then
dependency = Gem::Dependency.new name, req
dependency.prerelease = options[:prerelease]
@@ -236,13 +247,6 @@ to write the specification by hand. For example:
gem = fetcher.download_to_cache dependency
end
- if local? and not gem then
- source = Gem::Source::Local.new
- spec = source.find_gem name, req
-
- gem = source.download spec
- end
-
inst = Gem::Installer.new gem, options
inst.install
diff --git a/lib/rubygems/commands/setup_command.rb b/lib/rubygems/commands/setup_command.rb
index face77fae9c..681db0dc1d1 100644
--- a/lib/rubygems/commands/setup_command.rb
+++ b/lib/rubygems/commands/setup_command.rb
@@ -13,7 +13,7 @@ class Gem::Commands::SetupCommand < Gem::Command
super 'setup', 'Install RubyGems',
:format_executable => true, :document => %w[ri],
- :site_or_vendor => :sitelibdir,
+ :site_or_vendor => 'sitelibdir',
:destdir => '', :prefix => '', :previous_version => ''
add_option '--previous-version=VERSION',
@@ -36,7 +36,7 @@ class Gem::Commands::SetupCommand < Gem::Command
add_option '--[no-]vendor',
'Install into vendorlibdir not sitelibdir' do |vendor, options|
- options[:site_or_vendor] = vendor ? :vendorlibdir : :sitelibdir
+ options[:site_or_vendor] = vendor ? 'vendorlibdir' : 'sitelibdir'
end
add_option '--[no-]format-executable',
@@ -343,19 +343,19 @@ TEXT
site_or_vendor = options[:site_or_vendor]
if prefix.empty? then
- lib_dir = Gem::ConfigMap[site_or_vendor]
- bin_dir = Gem::ConfigMap[:bindir]
+ lib_dir = RbConfig::CONFIG[site_or_vendor]
+ bin_dir = RbConfig::CONFIG['bindir']
else
# Apple installed RubyGems into libdir, and RubyGems <= 1.1.0 gets
# confused about installation location, so switch back to
# sitelibdir/vendorlibdir.
if defined?(APPLE_GEM_HOME) and
# just in case Apple and RubyGems don't get this patched up proper.
- (prefix == Gem::ConfigMap[:libdir] or
+ (prefix == RbConfig::CONFIG['libdir'] or
# this one is important
- prefix == File.join(Gem::ConfigMap[:libdir], 'ruby')) then
- lib_dir = Gem::ConfigMap[site_or_vendor]
- bin_dir = Gem::ConfigMap[:bindir]
+ prefix == File.join(RbConfig::CONFIG['libdir'], 'ruby')) then
+ lib_dir = RbConfig::CONFIG[site_or_vendor]
+ bin_dir = RbConfig::CONFIG['bindir']
else
lib_dir = File.join prefix, 'lib'
bin_dir = File.join prefix, 'bin'
diff --git a/lib/rubygems/compatibility.rb b/lib/rubygems/compatibility.rb
index 5e8618fe39c..d06ade1fa66 100644
--- a/lib/rubygems/compatibility.rb
+++ b/lib/rubygems/compatibility.rb
@@ -33,6 +33,8 @@ end
module Gem
RubyGemsVersion = VERSION
+ # TODO remove at RubyGems 3
+
RbConfigPriorities = %w[
MAJOR
MINOR
@@ -45,7 +47,7 @@ module Gem
unless defined?(ConfigMap)
##
# Configuration settings from ::RbConfig
- ConfigMap = Hash.new do |cm, key|
+ ConfigMap = Hash.new do |cm, key| # TODO remove at RubyGems 3
cm[key] = RbConfig::CONFIG[key.to_s]
end
else
diff --git a/lib/rubygems/defaults.rb b/lib/rubygems/defaults.rb
index 715c0b71b36..6924f48e5ad 100644
--- a/lib/rubygems/defaults.rb
+++ b/lib/rubygems/defaults.rb
@@ -29,22 +29,22 @@ module Gem
def self.default_dir
path = if defined? RUBY_FRAMEWORK_VERSION then
[
- File.dirname(ConfigMap[:sitedir]),
+ File.dirname(RbConfig::CONFIG['sitedir']),
'Gems',
- ConfigMap[:ruby_version]
+ RbConfig::CONFIG['ruby_version']
]
- elsif ConfigMap[:rubylibprefix] then
+ elsif RbConfig::CONFIG['rubylibprefix'] then
[
- ConfigMap[:rubylibprefix],
+ RbConfig::CONFIG['rubylibprefix'],
'gems',
- ConfigMap[:ruby_version]
+ RbConfig::CONFIG['ruby_version']
]
else
[
- ConfigMap[:libdir],
+ RbConfig::CONFIG['libdir'],
ruby_engine,
'gems',
- ConfigMap[:ruby_version]
+ RbConfig::CONFIG['ruby_version']
]
end
@@ -74,7 +74,7 @@ module Gem
def self.user_dir
parts = [Gem.user_home, '.gem', ruby_engine]
- parts << ConfigMap[:ruby_version] unless ConfigMap[:ruby_version].empty?
+ parts << RbConfig::CONFIG['ruby_version'] unless RbConfig::CONFIG['ruby_version'].empty?
File.join parts
end
@@ -100,7 +100,7 @@ module Gem
# Deduce Ruby's --program-prefix and --program-suffix from its install name
def self.default_exec_format
- exec_format = ConfigMap[:ruby_install_name].sub('ruby', '%s') rescue '%s'
+ exec_format = RbConfig::CONFIG['ruby_install_name'].sub('ruby', '%s') rescue '%s'
unless exec_format =~ /%s/ then
raise Gem::Exception,
@@ -117,7 +117,7 @@ module Gem
if defined? RUBY_FRAMEWORK_VERSION then # mac framework support
'/usr/bin'
else # generic install
- ConfigMap[:bindir]
+ RbConfig::CONFIG['bindir']
end
end
diff --git a/lib/rubygems/deprecate.rb b/lib/rubygems/deprecate.rb
index 274d6a5c120..e19360da13a 100644
--- a/lib/rubygems/deprecate.rb
+++ b/lib/rubygems/deprecate.rb
@@ -50,7 +50,7 @@ module Gem::Deprecate
class_eval {
old = "_deprecated_#{name}"
alias_method old, name
- define_method name do |*args, &block| # TODO: really works on 1.8.7?
+ define_method name do |*args, &block|
klass = self.kind_of? Module
target = klass ? "#{self}." : "#{self.class}#"
msg = [ "NOTE: #{target}#{name} is deprecated",
diff --git a/lib/rubygems/installer.rb b/lib/rubygems/installer.rb
index f8eb2c2145f..33d2f78d46a 100644
--- a/lib/rubygems/installer.rb
+++ b/lib/rubygems/installer.rb
@@ -480,7 +480,7 @@ class Gem::Installer
#
def shebang(bin_file_name)
- ruby_name = Gem::ConfigMap[:ruby_install_name] if @env_shebang
+ ruby_name = RbConfig::CONFIG['ruby_install_name'] if @env_shebang
path = File.join gem_dir, spec.bindir, bin_file_name
first_line = File.open(path, "rb") {|file| file.gets}
@@ -493,7 +493,7 @@ class Gem::Installer
if which = Gem.configuration[:custom_shebang]
# replace bin_file_name with "ruby" to avoid endless loops
- which = which.gsub(/ #{bin_file_name}$/," #{Gem::ConfigMap[:ruby_install_name]}")
+ which = which.gsub(/ #{bin_file_name}$/," #{RbConfig::CONFIG['ruby_install_name']}")
which = which.gsub(/\$(\w+)/) do
case $1
diff --git a/lib/rubygems/platform.rb b/lib/rubygems/platform.rb
index e050959dc6f..1bcd7549ad4 100644
--- a/lib/rubygems/platform.rb
+++ b/lib/rubygems/platform.rb
@@ -16,7 +16,7 @@ class Gem::Platform
attr_accessor :version
def self.local
- arch = Gem::ConfigMap[:arch]
+ arch = RbConfig::CONFIG['arch']
arch = "#{arch}_60" if arch =~ /mswin32$/
@local ||= new(arch)
end
diff --git a/lib/rubygems/rdoc.rb b/lib/rubygems/rdoc.rb
index 52249dc267a..633bd893a5d 100644
--- a/lib/rubygems/rdoc.rb
+++ b/lib/rubygems/rdoc.rb
@@ -193,7 +193,7 @@ class Gem::RDoc # :nodoc: all
::RDoc::Parser::C.reset
args = @spec.rdoc_options
- args.concat @spec.require_paths
+ args.concat @spec.source_paths
args.concat @spec.extra_rdoc_files
case config_args = Gem.configuration[:rdoc]
diff --git a/lib/rubygems/request_set/lockfile.rb b/lib/rubygems/request_set/lockfile.rb
index 522caf15026..0433d2a7fc8 100644
--- a/lib/rubygems/request_set/lockfile.rb
+++ b/lib/rubygems/request_set/lockfile.rb
@@ -303,7 +303,12 @@ class Gem::RequestSet::Lockfile
type, data, = get [:text, :requirement]
if type == :text and column == 4 then
- last_spec = set.add name, data, Gem::Platform::RUBY
+ version, platform = data.split '-', 2
+
+ platform =
+ platform ? Gem::Platform.new(platform) : Gem::Platform::RUBY
+
+ last_spec = set.add name, version, platform
else
dependency = parse_dependency name, data
diff --git a/lib/rubygems/resolver.rb b/lib/rubygems/resolver.rb
index d455e03c057..15a96693e95 100644
--- a/lib/rubygems/resolver.rb
+++ b/lib/rubygems/resolver.rb
@@ -179,27 +179,6 @@ class Gem::Resolver
end
##
- # Finds the State in +states+ that matches the +conflict+ so that we can try
- # other possible sets.
- #
- # If no good candidate is found, the first state is tried.
-
- def find_conflict_state conflict, states # :nodoc:
- until states.empty? do
- state = states.pop
-
- explain :consider, state.dep, conflict.failed_dep
-
- if conflict.for_spec? state.spec
- state.conflicts << [state.spec, conflict]
- return state
- end
- end
-
- nil
- end
-
- ##
# Extracts the specifications that may be able to fulfill +dependency+ and
# returns those that match the local platform and all those that match.
diff --git a/lib/rubygems/resolver/installer_set.rb b/lib/rubygems/resolver/installer_set.rb
index e35e0aabecc..27e64551480 100644
--- a/lib/rubygems/resolver/installer_set.rb
+++ b/lib/rubygems/resolver/installer_set.rb
@@ -28,11 +28,10 @@ class Gem::Resolver::InstallerSet < Gem::Resolver::Set
@f = Gem::SpecFetcher.fetcher
- @all = Hash.new { |h,k| h[k] = [] }
@always_install = []
@ignore_dependencies = false
@ignore_installed = false
- @loaded_remote_specs = []
+ @remote_set = Gem::Resolver::BestSet.new if consider_remote?
@specs = {}
end
@@ -79,16 +78,7 @@ class Gem::Resolver::InstallerSet < Gem::Resolver::Set
end
end
- if consider_remote? then
- load_remote_specs dep
-
- @all[name].each do |remote_source, n|
- if dep.match? n then
- res << Gem::Resolver::IndexSpecification.new(
- self, n.name, n.version, remote_source, n.platform)
- end
- end
- end
+ res.concat @remote_set.find_all req if consider_remote?
res
end
@@ -102,27 +92,6 @@ class Gem::Resolver::InstallerSet < Gem::Resolver::Set
end
##
- # Loads remote prerelease specs if +dep+ is a prerelease dependency
-
- def load_remote_specs dep # :nodoc:
- types = [:released]
- types << :prerelease if dep.prerelease?
-
- types.each do |type|
- next if @loaded_remote_specs.include? type
- @loaded_remote_specs << type
-
- list, = @f.available_specs type
-
- list.each do |uri, specs|
- specs.each do |n|
- @all[n.name] << [uri, n]
- end
- end
- end
- end
-
- ##
# Called from IndexSpecification to get a true Specification
# object.
diff --git a/lib/rubygems/specification.rb b/lib/rubygems/specification.rb
index 59d71d378bb..e98f3284cd0 100644
--- a/lib/rubygems/specification.rb
+++ b/lib/rubygems/specification.rb
@@ -327,7 +327,7 @@ class Gem::Specification < Gem::BasicSpecification
add_bindir(@executables),
@extra_rdoc_files,
@extensions,
- ].flatten.sort.uniq.compact
+ ].flatten.uniq.compact.sort
end
######################################################################
diff --git a/lib/rubygems/test_case.rb b/lib/rubygems/test_case.rb
index 8dc37d67204..ff261f7816e 100644
--- a/lib/rubygems/test_case.rb
+++ b/lib/rubygems/test_case.rb
@@ -294,10 +294,10 @@ class Gem::TestCase < MiniTest::Unit::TestCase
Gem.searcher = nil
Gem::SpecFetcher.fetcher = nil
- @orig_BASERUBY = Gem::ConfigMap[:BASERUBY]
- Gem::ConfigMap[:BASERUBY] = Gem::ConfigMap[:ruby_install_name]
+ @orig_BASERUBY = RbConfig::CONFIG['BASERUBY']
+ RbConfig::CONFIG['BASERUBY'] = RbConfig::CONFIG['ruby_install_name']
- @orig_arch = Gem::ConfigMap[:arch]
+ @orig_arch = RbConfig::CONFIG['arch']
if win_platform?
util_set_arch 'i386-mswin32'
@@ -315,8 +315,8 @@ class Gem::TestCase < MiniTest::Unit::TestCase
def teardown
$LOAD_PATH.replace @orig_LOAD_PATH if @orig_LOAD_PATH
- Gem::ConfigMap[:BASERUBY] = @orig_BASERUBY
- Gem::ConfigMap[:arch] = @orig_arch
+ RbConfig::CONFIG['BASERUBY'] = @orig_BASERUBY
+ RbConfig::CONFIG['arch'] = @orig_arch
if defined? Gem::RemoteFetcher then
Gem::RemoteFetcher.fetcher = nil
@@ -898,7 +898,7 @@ Also, a list:
# Set the platform to +arch+
def util_set_arch(arch)
- Gem::ConfigMap[:arch] = arch
+ RbConfig::CONFIG['arch'] = arch
platform = Gem::Platform.new arch
Gem.instance_variable_set :@platforms, nil
diff --git a/lib/rubygems/uninstaller.rb b/lib/rubygems/uninstaller.rb
index 4cb2a1d3333..fa838333cd4 100644
--- a/lib/rubygems/uninstaller.rb
+++ b/lib/rubygems/uninstaller.rb
@@ -237,7 +237,7 @@ class Gem::Uninstaller
unless path_ok?(@gem_home, spec) or
(@user_install and path_ok?(Gem.user_dir, spec)) then
e = Gem::GemNotInHomeException.new \
- "Gem is not installed in directory #{@gem_home}"
+ "Gem '#{spec.full_name}' is not installed in directory #{@gem_home}"
e.spec = spec
raise e
diff --git a/test/rubygems/test_gem.rb b/test/rubygems/test_gem.rb
index 759c2fe9070..513f2d4e58e 100644
--- a/test/rubygems/test_gem.rb
+++ b/test/rubygems/test_gem.rb
@@ -199,30 +199,30 @@ class TestGem < Gem::TestCase
end
def test_self_default_exec_format
- orig_RUBY_INSTALL_NAME = Gem::ConfigMap[:ruby_install_name]
- Gem::ConfigMap[:ruby_install_name] = 'ruby'
+ orig_RUBY_INSTALL_NAME = RbConfig::CONFIG['ruby_install_name']
+ RbConfig::CONFIG['ruby_install_name'] = 'ruby'
assert_equal '%s', Gem.default_exec_format
ensure
- Gem::ConfigMap[:ruby_install_name] = orig_RUBY_INSTALL_NAME
+ RbConfig::CONFIG['ruby_install_name'] = orig_RUBY_INSTALL_NAME
end
def test_self_default_exec_format_18
- orig_RUBY_INSTALL_NAME = Gem::ConfigMap[:ruby_install_name]
- Gem::ConfigMap[:ruby_install_name] = 'ruby18'
+ orig_RUBY_INSTALL_NAME = RbConfig::CONFIG['ruby_install_name']
+ RbConfig::CONFIG['ruby_install_name'] = 'ruby18'
assert_equal '%s18', Gem.default_exec_format
ensure
- Gem::ConfigMap[:ruby_install_name] = orig_RUBY_INSTALL_NAME
+ RbConfig::CONFIG['ruby_install_name'] = orig_RUBY_INSTALL_NAME
end
def test_self_default_exec_format_jruby
- orig_RUBY_INSTALL_NAME = Gem::ConfigMap[:ruby_install_name]
- Gem::ConfigMap[:ruby_install_name] = 'jruby'
+ orig_RUBY_INSTALL_NAME = RbConfig::CONFIG['ruby_install_name']
+ RbConfig::CONFIG['ruby_install_name'] = 'jruby'
assert_equal 'j%s', Gem.default_exec_format
ensure
- Gem::ConfigMap[:ruby_install_name] = orig_RUBY_INSTALL_NAME
+ RbConfig::CONFIG['ruby_install_name'] = orig_RUBY_INSTALL_NAME
end
def test_self_default_sources
@@ -230,6 +230,7 @@ class TestGem < Gem::TestCase
end
def test_self_detect_gemdeps
+ skip 'Insecure operation - chdir' if RUBY_VERSION <= "1.8.7"
rubygems_gemdeps, ENV['RUBYGEMS_GEMDEPS'] = ENV['RUBYGEMS_GEMDEPS'], '-'
FileUtils.mkdir_p 'detect/a/b'
@@ -565,24 +566,43 @@ class TestGem < Gem::TestCase
end
def test_self_prefix_libdir
- orig_libdir = Gem::ConfigMap[:libdir]
- Gem::ConfigMap[:libdir] = @@project_dir
+ orig_libdir = RbConfig::CONFIG['libdir']
+ RbConfig::CONFIG['libdir'] = @@project_dir
assert_nil Gem.prefix
ensure
- Gem::ConfigMap[:libdir] = orig_libdir
+ RbConfig::CONFIG['libdir'] = orig_libdir
end
def test_self_prefix_sitelibdir
- orig_sitelibdir = Gem::ConfigMap[:sitelibdir]
- Gem::ConfigMap[:sitelibdir] = @@project_dir
+ orig_sitelibdir = RbConfig::CONFIG['sitelibdir']
+ RbConfig::CONFIG['sitelibdir'] = @@project_dir
assert_nil Gem.prefix
ensure
- Gem::ConfigMap[:sitelibdir] = orig_sitelibdir
+ RbConfig::CONFIG['sitelibdir'] = orig_sitelibdir
+ end
+
+ def test_self_read_binary
+ open 'test', 'w' do |io|
+ io.write "\xCF\x80"
+ end
+
+ assert_equal ["\xCF", "\x80"], Gem.read_binary('test').chars.to_a
+
+ skip 'chmod not supported' if Gem.win_platform?
+
+ begin
+ File.chmod 0444, 'test'
+
+ assert_equal ["\xCF", "\x80"], Gem.read_binary('test').chars.to_a
+ ensure
+ File.chmod 0644, 'test'
+ end
end
def test_self_refresh
+ skip 'Insecure operation - mkdir' if RUBY_VERSION <= "1.8.7"
util_make_gems
a1_spec = @a1.spec_file
@@ -602,6 +622,7 @@ class TestGem < Gem::TestCase
end
def test_self_refresh_keeps_loaded_specs_activated
+ skip 'Insecure operation - mkdir' if RUBY_VERSION <= "1.8.7"
util_make_gems
a1_spec = @a1.spec_file
@@ -624,46 +645,44 @@ class TestGem < Gem::TestCase
def test_self_ruby_escaping_spaces_in_path
orig_ruby = Gem.ruby
- orig_bindir = Gem::ConfigMap[:bindir]
- orig_ruby_install_name = Gem::ConfigMap[:ruby_install_name]
- orig_exe_ext = Gem::ConfigMap[:EXEEXT]
+ orig_bindir = RbConfig::CONFIG['bindir']
+ orig_ruby_install_name = RbConfig::CONFIG['ruby_install_name']
+ orig_exe_ext = RbConfig::CONFIG['EXEEXT']
- Gem::ConfigMap[:bindir] = "C:/Ruby 1.8/bin"
- Gem::ConfigMap[:ruby_install_name] = "ruby"
- Gem::ConfigMap[:EXEEXT] = ".exe"
+ RbConfig::CONFIG['bindir'] = "C:/Ruby 1.8/bin"
+ RbConfig::CONFIG['ruby_install_name'] = "ruby"
+ RbConfig::CONFIG['EXEEXT'] = ".exe"
Gem.instance_variable_set("@ruby", nil)
assert_equal "\"C:/Ruby 1.8/bin/ruby.exe\"", Gem.ruby
ensure
Gem.instance_variable_set("@ruby", orig_ruby)
- Gem::ConfigMap[:bindir] = orig_bindir
- Gem::ConfigMap[:ruby_install_name] = orig_ruby_install_name
- Gem::ConfigMap[:EXEEXT] = orig_exe_ext
+ RbConfig::CONFIG['bindir'] = orig_bindir
+ RbConfig::CONFIG['ruby_install_name'] = orig_ruby_install_name
+ RbConfig::CONFIG['EXEEXT'] = orig_exe_ext
end
def test_self_ruby_path_without_spaces
orig_ruby = Gem.ruby
- orig_bindir = Gem::ConfigMap[:bindir]
- orig_ruby_install_name = Gem::ConfigMap[:ruby_install_name]
- orig_exe_ext = Gem::ConfigMap[:EXEEXT]
+ orig_bindir = RbConfig::CONFIG['bindir']
+ orig_ruby_install_name = RbConfig::CONFIG['ruby_install_name']
+ orig_exe_ext = RbConfig::CONFIG['EXEEXT']
- Gem::ConfigMap[:bindir] = "C:/Ruby18/bin"
- Gem::ConfigMap[:ruby_install_name] = "ruby"
- Gem::ConfigMap[:EXEEXT] = ".exe"
+ RbConfig::CONFIG['bindir'] = "C:/Ruby18/bin"
+ RbConfig::CONFIG['ruby_install_name'] = "ruby"
+ RbConfig::CONFIG['EXEEXT'] = ".exe"
Gem.instance_variable_set("@ruby", nil)
assert_equal "C:/Ruby18/bin/ruby.exe", Gem.ruby
ensure
Gem.instance_variable_set("@ruby", orig_ruby)
- Gem::ConfigMap[:bindir] = orig_bindir
- Gem::ConfigMap[:ruby_install_name] = orig_ruby_install_name
- Gem::ConfigMap[:EXEEXT] = orig_exe_ext
+ RbConfig::CONFIG['bindir'] = orig_bindir
+ RbConfig::CONFIG['ruby_install_name'] = orig_ruby_install_name
+ RbConfig::CONFIG['EXEEXT'] = orig_exe_ext
end
def test_self_ruby_api_version
- orig_MAJOR, Gem::ConfigMap[:MAJOR] = Gem::ConfigMap[:MAJOR], '1'
- orig_MINOR, Gem::ConfigMap[:MINOR] = Gem::ConfigMap[:MINOR], '2'
- orig_TEENY, Gem::ConfigMap[:TEENY] = Gem::ConfigMap[:TEENY], '3'
+ orig_ruby_version, RbConfig::CONFIG['ruby_version'] = RbConfig::CONFIG['ruby_version'], '1.2.3'
Gem.instance_variable_set :@ruby_api_version, nil
@@ -671,9 +690,7 @@ class TestGem < Gem::TestCase
ensure
Gem.instance_variable_set :@ruby_api_version, nil
- Gem::ConfigMap[:MAJOR] = orig_MAJOR
- Gem::ConfigMap[:MINOR] = orig_MINOR
- Gem::ConfigMap[:TEENY] = orig_TEENY
+ RbConfig::CONFIG['ruby_version'] = orig_ruby_version
end
def test_self_ruby_version_1_8_5
@@ -825,7 +842,7 @@ class TestGem < Gem::TestCase
def test_self_user_dir
parts = [@userhome, '.gem', Gem.ruby_engine]
- parts << Gem::ConfigMap[:ruby_version] unless Gem::ConfigMap[:ruby_version].empty?
+ parts << RbConfig::CONFIG['ruby_version'] unless RbConfig::CONFIG['ruby_version'].empty?
assert_equal File.join(parts), Gem.user_dir
end
@@ -857,6 +874,7 @@ class TestGem < Gem::TestCase
end
def test_self_needs_picks_up_unresolved_deps
+ skip 'loading from unsafe file' if RUBY_VERSION <= "1.8.7"
save_loaded_features do
util_clear_gems
a = util_spec "a", "1"
@@ -949,6 +967,7 @@ class TestGem < Gem::TestCase
end
def test_load_plugins
+ skip 'Insecure operation - chdir' if RUBY_VERSION <= "1.8.7"
plugin_path = File.join "lib", "rubygems_plugin.rb"
Dir.chdir @tempdir do
@@ -1102,6 +1121,7 @@ class TestGem < Gem::TestCase
end
def test_auto_activation_of_detected_gemdeps_file
+ skip 'Insecure operation - chdir' if RUBY_VERSION <= "1.8.7"
util_clear_gems
a = new_spec "a", "1", nil, "lib/a.rb"
@@ -1264,6 +1284,7 @@ class TestGem < Gem::TestCase
end
def test_use_gemdeps_automatic
+ skip 'Insecure operation - chdir' if RUBY_VERSION <= "1.8.7"
rubygems_gemdeps, ENV['RUBYGEMS_GEMDEPS'] = ENV['RUBYGEMS_GEMDEPS'], '-'
spec = util_spec 'a', 1
@@ -1300,6 +1321,7 @@ class TestGem < Gem::TestCase
end
def test_use_gemdeps_specific
+ skip 'Insecure operation - read' if RUBY_VERSION <= "1.8.7"
rubygems_gemdeps, ENV['RUBYGEMS_GEMDEPS'] = ENV['RUBYGEMS_GEMDEPS'], 'x'
spec = util_spec 'a', 1
diff --git a/test/rubygems/test_gem_commands_contents_command.rb b/test/rubygems/test_gem_commands_contents_command.rb
index d87e84fc829..7f5cf22223c 100644
--- a/test/rubygems/test_gem_commands_contents_command.rb
+++ b/test/rubygems/test_gem_commands_contents_command.rb
@@ -169,9 +169,9 @@ lib/foo.rb
end
expected = [
- File.join(Gem::ConfigMap[:bindir], 'default_command'),
- File.join(Gem::ConfigMap[:rubylibdir], 'default/gem.rb'),
- File.join(Gem::ConfigMap[:archdir], 'default_gem.so')
+ File.join(RbConfig::CONFIG['bindir'], 'default_command'),
+ File.join(RbConfig::CONFIG['rubylibdir'], 'default/gem.rb'),
+ File.join(RbConfig::CONFIG['archdir'], 'default_gem.so')
].sort.join "\n"
assert_equal expected, @ui.output.chomp
diff --git a/test/rubygems/test_gem_commands_environment_command.rb b/test/rubygems/test_gem_commands_environment_command.rb
index 253c459d942..bb7589f50de 100644
--- a/test/rubygems/test_gem_commands_environment_command.rb
+++ b/test/rubygems/test_gem_commands_environment_command.rb
@@ -26,7 +26,7 @@ class TestGemCommandsEnvironmentCommand < Gem::TestCase
assert_match %r|INSTALLATION DIRECTORY: #{Regexp.escape @gemhome}|,
@ui.output
assert_match %r|RUBYGEMS PREFIX: |, @ui.output
- assert_match %r|RUBY EXECUTABLE:.*#{Gem::ConfigMap[:ruby_install_name]}|,
+ assert_match %r|RUBY EXECUTABLE:.*#{RbConfig::CONFIG['ruby_install_name']}|,
@ui.output
assert_match %r|EXECUTABLE DIRECTORY:|, @ui.output
assert_match %r|RUBYGEMS PLATFORMS:|, @ui.output
diff --git a/test/rubygems/test_gem_commands_install_command.rb b/test/rubygems/test_gem_commands_install_command.rb
index 00bbf7bae7e..6315cb5d95b 100644
--- a/test/rubygems/test_gem_commands_install_command.rb
+++ b/test/rubygems/test_gem_commands_install_command.rb
@@ -316,6 +316,7 @@ ERROR: Possible alternatives: non_existent_with_hint
end
def test_execute_rdoc
+ skip if RUBY_VERSION <= "1.8.7"
specs = spec_fetcher do |fetcher|
fetcher.gem 'a', 2
end
@@ -559,6 +560,20 @@ ERROR: Possible alternatives: non_existent_with_hint
assert_equal %w[a-2], @cmd.installed_specs.map { |spec| spec.full_name }
end
+ def test_install_gem_ignore_dependencies_specific_file
+ spec = quick_spec 'a', 2
+
+ util_build_gem spec
+
+ FileUtils.mv spec.cache_file, @tempdir
+
+ @cmd.options[:ignore_dependencies] = true
+
+ @cmd.install_gem File.join(@tempdir, spec.file_name), nil
+
+ assert_equal %w[a-2], @cmd.installed_specs.map { |s| s.full_name }
+ end
+
def test_parses_requirement_from_gemname
spec_fetcher do |fetcher|
fetcher.gem 'a', 2
diff --git a/test/rubygems/test_gem_commands_update_command.rb b/test/rubygems/test_gem_commands_update_command.rb
index 7537c1c9c10..d259383ba2f 100644
--- a/test/rubygems/test_gem_commands_update_command.rb
+++ b/test/rubygems/test_gem_commands_update_command.rb
@@ -217,6 +217,7 @@ class TestGemCommandsUpdateCommand < Gem::TestCase
end
def test_execute_rdoc
+ skip if RUBY_VERSION <= "1.8.7"
spec_fetcher do |fetcher|
fetcher.gem 'a', 2
@@ -239,7 +240,6 @@ class TestGemCommandsUpdateCommand < Gem::TestCase
a2 = @specs['a-2']
- assert_path_exists File.join(a2.doc_dir, 'ri')
assert_path_exists File.join(a2.doc_dir, 'rdoc')
end
diff --git a/test/rubygems/test_gem_dependency_installer.rb b/test/rubygems/test_gem_dependency_installer.rb
index 0a82fa63cbb..352ebbb54ff 100644
--- a/test/rubygems/test_gem_dependency_installer.rb
+++ b/test/rubygems/test_gem_dependency_installer.rb
@@ -551,7 +551,7 @@ class TestGemDependencyInstaller < Gem::TestCase
env = "/\\S+/env" unless Gem.win_platform?
- assert_match %r|\A#!#{env} #{Gem::ConfigMap[:ruby_install_name]}\n|,
+ assert_match %r|\A#!#{env} #{RbConfig::CONFIG['ruby_install_name']}\n|,
File.read(File.join(@gemhome, 'bin', 'a_bin'))
end
diff --git a/test/rubygems/test_gem_installer.rb b/test/rubygems/test_gem_installer.rb
index 615a9b57ba4..54ac853135b 100644
--- a/test/rubygems/test_gem_installer.rb
+++ b/test/rubygems/test_gem_installer.rb
@@ -84,8 +84,8 @@ load Gem.bin_path('a', 'executable', version)
orig_RUBY_FRAMEWORK_VERSION = RUBY_FRAMEWORK_VERSION
Object.send :remove_const, :RUBY_FRAMEWORK_VERSION
end
- orig_bindir = Gem::ConfigMap[:bindir]
- Gem::ConfigMap[:bindir] = Gem.bindir
+ orig_bindir = RbConfig::CONFIG['bindir']
+ RbConfig::CONFIG['bindir'] = Gem.bindir
util_conflict_executable false
@@ -102,7 +102,7 @@ load Gem.bin_path('a', 'executable', version)
ensure
Object.const_set :RUBY_FRAMEWORK_VERSION, orig_RUBY_FRAMEWORK_VERSION if
orig_RUBY_FRAMEWORK_VERSION
- Gem::ConfigMap[:bindir] = orig_bindir
+ RbConfig::CONFIG['bindir'] = orig_bindir
end
def test_check_executable_overwrite_format_executable
@@ -1192,7 +1192,7 @@ gem 'other', version
env_shebang = "/usr/bin/env" unless Gem.win_platform?
- assert_equal("#!#{env_shebang} #{Gem::ConfigMap[:ruby_install_name]}",
+ assert_equal("#!#{env_shebang} #{RbConfig::CONFIG['ruby_install_name']}",
shebang)
end
diff --git a/test/rubygems/test_gem_request_set_lockfile.rb b/test/rubygems/test_gem_request_set_lockfile.rb
index 9e0cab4d1a8..0be69bf92b3 100644
--- a/test/rubygems/test_gem_request_set_lockfile.rb
+++ b/test/rubygems/test_gem_request_set_lockfile.rb
@@ -218,6 +218,7 @@ GEM
c (~> 4)
d
e (~> 5.0, >= 5.0.1)
+ b (3-x86_64-linux)
PLATFORMS
#{Gem::Platform::RUBY}
@@ -238,7 +239,14 @@ DEPENDENCIES
assert lockfile_set, 'could not find a LockSet'
- assert_equal %w[a-2], lockfile_set.specs.map { |tuple| tuple.full_name }
+ assert_equal %w[a-2 b-3], lockfile_set.specs.map { |tuple| tuple.full_name }
+
+ expected = [
+ Gem::Platform::RUBY,
+ Gem::Platform.new('x86_64-linux'),
+ ]
+
+ assert_equal expected, lockfile_set.specs.map { |tuple| tuple.platform }
spec = lockfile_set.specs.first
diff --git a/test/rubygems/test_gem_specification.rb b/test/rubygems/test_gem_specification.rb
index 7aa9d5aeb17..b72a5d1baf0 100644
--- a/test/rubygems/test_gem_specification.rb
+++ b/test/rubygems/test_gem_specification.rb
@@ -999,8 +999,8 @@ dependencies: []
assert_equal 'summary', spec.summary
assert_same spec.summary, new_spec.summary
- assert_equal %w[lib/file.rb test/file.rb bin/exec README.txt
- ext/extconf.rb].sort,
+ assert_equal %w[README.txt bin/exec ext/extconf.rb lib/file.rb
+ test/file.rb].sort,
spec.files
refute_same spec.files, new_spec.files, 'files'
@@ -1109,7 +1109,31 @@ dependencies: []
@a2.executable = 'app'
assert_equal nil, @a2.bindir
- assert_equal %w[lib/code.rb app].sort, @a2.files
+ assert_equal %w[app lib/code.rb].sort, @a2.files
+ end
+
+ def test_extensions_equals_nil
+ @a2.instance_variable_set(:@extensions, nil)
+ assert_equal nil, @a2.instance_variable_get(:@extensions)
+ assert_equal %w[lib/code.rb], @a2.files
+ end
+
+ def test_test_files_equals_nil
+ @a2.instance_variable_set(:@test_files, nil)
+ assert_equal nil, @a2.instance_variable_get(:@test_files)
+ assert_equal %w[lib/code.rb], @a2.files
+ end
+
+ def test_executables_equals_nil
+ @a2.instance_variable_set(:@executables, nil)
+ assert_equal nil, @a2.instance_variable_get(:@executables)
+ assert_equal %w[lib/code.rb], @a2.files
+ end
+
+ def test_extra_rdoc_files_equals_nil
+ @a2.instance_variable_set(:@extra_rdoc_files, nil)
+ assert_equal nil, @a2.instance_variable_get(:@extra_rdoc_files)
+ assert_equal %w[lib/code.rb], @a2.files
end
def test_build_extensions
@@ -1437,7 +1461,7 @@ dependencies: []
def test_executable_equals
@a2.executable = 'app'
assert_equal 'app', @a2.executable
- assert_equal %w[lib/code.rb bin/app].sort, @a2.files
+ assert_equal %w[bin/app lib/code.rb].sort, @a2.files
end
def test_extensions
@@ -1785,6 +1809,22 @@ dependencies: []
assert_kind_of Gem::Source::Installed, @a1.source
end
+ def test_source_paths
+ ext_spec
+
+ @ext.require_paths = %w[lib ext foo]
+ @ext.extensions << 'bar/baz'
+
+ expected = %w[
+ lib
+ ext
+ foo
+ bar
+ ]
+
+ assert_equal expected, @ext.source_paths
+ end
+
def test_full_require_paths
ext_spec
@@ -2435,7 +2475,7 @@ duplicate dependency on b (>= 1.2.3), (~> 1.2) use:
assert_equal '["lib2"] are not files', e.message
end
- assert_equal %w[lib/code.rb test/suite.rb bin/exec ext/a/extconf.rb lib2].sort,
+ assert_equal %w[bin/exec ext/a/extconf.rb lib/code.rb lib2 test/suite.rb].sort,
@a1.files
end
diff --git a/test/rubygems/test_gem_uninstaller.rb b/test/rubygems/test_gem_uninstaller.rb
index 1eea30fb940..11fdaf68e22 100644
--- a/test/rubygems/test_gem_uninstaller.rb
+++ b/test/rubygems/test_gem_uninstaller.rb
@@ -131,6 +131,23 @@ class TestGemUninstaller < Gem::InstallerTestCase
Gem::Installer.exec_format = nil
end
+ def test_remove_not_in_home
+ uninstaller = Gem::Uninstaller.new nil, :install_dir => "#{@gemhome}2"
+
+ e = assert_raises Gem::GemNotInHomeException do
+ use_ui ui do
+ uninstaller.remove @spec
+ end
+ end
+
+ expected =
+ "Gem '#{@spec.full_name}' is not installed in directory #{@gemhome}2"
+
+ assert_equal expected, e.message
+
+ assert_path_exists @spec.gem_dir
+ end
+
def test_path_ok_eh
uninstaller = Gem::Uninstaller.new nil